/*
*
*
*  Simple Interpreter (main.c)
*  Mafice <mafice@mflabo.net>
*
*
*/

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <Resea/types.h>
#include <Resea/io.h>
#include <Resea/interrupt.h>


#define CMD_MAX   128

void keyboardISR (void);
int  getchar     (void);
int  strcmp      (const char *str1, const char *str2);
void puts        (const char *str);


int startupInterpreter (void){

 int   i, j, ch;
 char  line[CMD_MAX+1];
 char  *command[CMD_MAX];
 bool  err;

  setISR(1,  (offset_t) &keyboardISR);
  puts("Welcome to Resea 3.0 (Hydrangea)");
  puts("");

  for(;;){

    for(i=0; i < CMD_MAX; i++)
      command[i] = NULL;

    err = false;
    i   = 0;


    //
    //
    //  コマンドラインを読み取る
    //
    //

    putchar('(');
    putchar('s');
    putchar('h');
    putchar('e');
    putchar('l');
    putchar('l');
    putchar(')');
    putchar(' ');

    do{

      ch = getchar();
      line[i] = (char) ch;
      putchar((char) ch);

      i++;
      if(i >= CMD_MAX){
        puts("ERR: The command line is too long.");
        err = true;
        break;
      }

    }while(line[i-1] != '\n');

    line[i-1] = '\0';

    if(err){
      err = false;
      continue;
    }




    //
    //
    //  コマンドを解析
    //
    //

    //スペースで区切る
    command[0] = &line[0];

    for(i=0, j=1; line[i]!='\0'; i++){

      if(line[i] == ' '){
        line[i]    = '\0';
        command[j] = &line[i+1];
        j++;
      }
    }



    //
    //
    //  実行
    //
    //

    if(strcmp("echo", command[0]) == 0){

      if(command[1] == NULL)
        continue;

      for(i=0; command[1][i] != '\0'; i++)
        putchar(command[1][i]);

      putchar('\n');
      continue;
    }


    if(strcmp("wakaran", command[0]) == 0){

      puts("SOREHA KOMATTA");
      continue;
    }

    puts("ERR: Unknown command.");

  } // for(;;);
}


